<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>Insert title here</title>
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
</head>
<body>
<script type="text/javascript">
function* foo(){
	var index = 0;
	while (index <= 2) {
		// index가 3이 되면
        // yield의 value는 undefined, done은 true가 된다.
		yield index++;
	}
}

var iterator = foo();
console.log(iterator);
console.log(iterator.next()); // { value: 0, done: false }
console.log(iterator.next()); // { value: 1, done: false }
console.log(iterator.next()); // { value: 2, done: false }
console.log(iterator.next()); // { value: undefined, done: true }

// yield 함수에 값 입력하는 방법
function* add() {
	console.log('숫자 계산');
	const input1 = yield '첫번째 숫자 입력:';
	console.log("입력값1: ", input1);
	
	const input2 = yield '두번째 숫자 입력:';
	console.log("입력값2: ", input2);
	
	return input1 + input2;
}

const iter2 = add();
// 첫번째 next 호출은 함수의 시작부분부터 첫번째 yield문까지만 실행된다.
// 따라서 처음 10은 입력에 안 드간다.
console.log("1: ", iter2.next(10));
console.log("2: ", iter2.next(20));
console.log("3: ", iter2.next(30));

// yield* 사용 예시
function* g4() {
	yield* [1, 2, 3];
	return "foo";
}

const iter3 = g4();
console.log(iter3.next()); // { value: 1, done: false }
console.log(iter3.next()); // { value: 2, done: false }
console.log(iter3.next()); // { value: 3, done: false }
console.log(iter3.next());
</script>
</body>
</html>